"""
__run_details__
special table for the run detail table
"""
from Table import *

class RunDetails(Table):
  name="runsDetails"
  numDetails=['numstreamers','numexprcompleted','numexpresstotal','numexpresstotalstreamers','numexpressmerged','numexpressmergetotal','numrepackcompleted','numrepackedtotal','numrepackmerged','numrepackmergedexported','numrecotemp','numrecotemptotal','numrecocompleted','numrecototal','numrecomerged','numrecomergedexported','numalcatemp','numalcatemptotal','numalcacompleted','numalcatotal','numalcamerged','numalcamergedexported']
#,]
    
  def __init__(self,DASUrl,rownum,params):
    self.DASUrl=DASUrl
    self.rownum=rownum
    self.params=params
    Table.__init__(self,DASUrl,'lastruns')
    self.runs = self.data
    
    self.Nruns=len(self.runs)
    self.data=[]
    self.tableContent=runDetailContent(self.params,self.rownum)
    
    self.downLimit=self.tableContent.downLimit
    self.upLimit=self.tableContent.downLimit+min(self.rownum,self.Nruns-self.tableContent.downLimit)
    
    self.higherRun=self.runs[self.downLimit]['run']
    self.lowerRun=self.runs[self.upLimit-1]['run']
    
    #fetch statsNum information
    for url in self.numDetails:
      setattr(self,url,self.fetcher(self.DASUrl+url+'?lowerrunid='+str(self.lowerRun)+'&higherrunid='+str(self.higherRun)))
      #print "NUM_INFO:"+str(getattr(self,url))
    startValue=0
    self.tableContent.title=self.tableContent.title%(str(self.Nruns))
    try: #if I am trying to open a page with 0 values it raises an exception!
     
     for i in range(self.downLimit,self.upLimit):
       run=self.runs[i]['run']
       singleRunData=self.fetcher(self.DASUrl+'runfilesdetails?run='+str(run))
       if singleRunData!=[]:
        #updating single run properties
        for attr in self.numDetails:
         singleRunData[0].update({attr:self.getAttrByRun(getattr(self,attr),run)})
        self.data+=singleRunData 
       else: self.data=[]
    except Exception, e:
           #  if there are exceptions here, check the column DAS queries and their results!!!
           #  Every query MUST return a 'run_id' value and a 'count' one
           print "Column generation error: check DAS queries and their results!"
           print "Exception:"+ str(e) 
           self.data=[] 

       
  def buildRunDetailsCode(self):
      return self.longTableCode(self.tableContent,"system?")
     
          

  def getAttrByRun(self,valueList, run):
     index=self.binary_search(valueList,run,'run_id')
     #print "INDEX="+str(index)
     if index>=0:
        return valueList[index]['count']
     #not in the list: value=0
     return 0
  
  
  def binary_search(self,a, x, attrName, lo=0, hi=None):
    if hi is None:
        hi = len(a)
    while lo < hi:
        mid = (lo+hi)//2
        midval = a[mid]['run_id']
        #print "MIDVAL="+str(midval) + "   "+str(x)
        if midval < x:
            lo = mid+1
        elif midval > x: 
            hi = mid
        else:
            return mid
    return -1
